unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, VrControls, VrLevelBar, Mask, JvExMask, JvSpin, ALAudioIn,
  MidiOut, MidiIn, MidiType, MonProcs, MidiCons, ExtCtrls, OoMisc, AdStatLt,
  ActnList, ComCtrls, Menus, ALCommonFilter, ALGenericFilter, rmScale,
  IniFiles, ALCommonPlayer, ALWavePlayer, ALAudioOut, Buttons,
  AdvEdit, AdvEdBtn, AdvFileNameEdit, VrAudio, AdvCombo, AdvSpin,
  VrHPTimerFunc, ALCommonMeter, ALPPMMeter;

type
  TMyData = record
    Data: Array[0..2] of Byte;
    Len: byte;
  end;
  TMyWavePlayer = record
    WP: TvrWave;
    FileStartLocked: boolean;
  end;
  TMyWavePlayers = Array[0..1] of TMyWavePlayer;
  TMyMidi = record
    //FMyMIDIIn: TMidiInput;
    FMyMIDIOut: TMidiOutput;
    OutputDeviceName: string;
    OutVelFollowAudioInLevel0: boolean;
    OutVelFollowAudioInLevel1: boolean;
    Channel: byte;
    Note0On: boolean;
    Note0Str: string;
    Note0Data: byte;
    Note1On: boolean;
    Note1Str: string;
    Note1Data: byte;
  end;
  TMyAudio = record
    InputDeviceName: string;
    OutputDeviceName: string;
    LeftThres: double;
    RightThres: double;
    OutVolFollowAudioInLevel0: boolean;
    OutVolFollowAudioInLevel1: boolean;
  end;
  TAudioParams = record
    Channels: word;
    Bits: word;
    SampleRate: integer;
    //WaveFormat: word;
    //SamplesNumber: integer;
    //Length: extended;
    BufferSize: integer;
    MaxValue: cardinal;
    MinLevelInDb: double;
    MaxLevelInDb: double;
  end;

type
  TfmMain = class(TForm)
    VuAudioRight: TVrLevelBar;
    VuAudioLeft: TVrLevelBar;
    lblVuAudioLeft: TLabel;
    lblVuAudioRight: TLabel;
    ALAudioIn1: TALAudioIn;
    TimerMidiOut: TTimer;
    LedMidiOutData: TApdStatusLight;
    Label5: TLabel;
    LedMidiOutState: TApdStatusLight;
    Label6: TLabel;
    ledAudioInState: TApdStatusLight;
    Label7: TLabel;
    ActionList1: TActionList;
    ActAppAbout: TAction;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Aide1: TMenuItem;
    Apropos1: TMenuItem;
    ActAppClose: TAction;
    Quitter1: TMenuItem;
    StatusBar1: TStatusBar;
    ALGenericFilter1: TALGenericFilter;
    lblClip: TLabel;
    Trigger1: TMenuItem;
    ActTriggerStart: TAction;
    ActTriggerStop: TAction;
    Start1: TMenuItem;
    Stop1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    lblLeftLevelInDb: TLabel;
    lblRightLevelInDb: TLabel;
    scAudioTrigRightThres: TrmScale;
    ledLeftThres: TApdStatusLight;
    ledRightThres: TApdStatusLight;
    scAudioTrigLeftThres: TrmScale;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label3: TLabel;
    lstInputDevices: TComboBox;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    Label10: TLabel;
    lstMidiOut: TComboBox;
    lstMidiOutChannel: TComboBox;
    cbMidiOutVelFollowAudioInLevel: TCheckBox;
    Label11: TLabel;
    lstAudioInputBufferSize: TComboBox;
    lstAudioInputSampleRate: TComboBox;
    Label12: TLabel;
    Label13: TLabel;
    lstAudioInputBits: TComboBox;
    Label14: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Edit1: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    lstAudioInputChannels: TComboBox;
    Label21: TLabel;
    TabSheet4: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    Label22: TLabel;
    Label9: TLabel;
    rbStartMidiNote0: TRadioButton;
    rbStartAudioFile0: TRadioButton;
    Label24: TLabel;
    rbStartMidiNote1: TRadioButton;
    rbStartAudioFile1: TRadioButton;
    Bevel1: TBevel;
    Label25: TLabel;
    Label26: TLabel;
    lstOutputDevices: TComboBox;
    ALAudioOut1: TALAudioOut;
    ALWavePlayer1: TALWavePlayer;
    ledAudioOutState: TApdStatusLight;
    Label27: TLabel;
    OpenDialog1: TOpenDialog;
    MidiOutput1: TMidiOutput;
    VrWave0: TVrWave;
    VrWave1: TVrWave;
    edAudioOutFileName0: TAdvFileNameEdit;
    edAudioOutFileName1: TAdvFileNameEdit;
    lstMidiOutNote0: TAdvComboBox;
    lstMidiOutNote1: TAdvComboBox;
    edAudioTrigLeftThres: TAdvSpinEdit;
    edAudioTrigRightThres: TAdvSpinEdit;
    VrHPTimer0: TVrHPTimer;
    VrHPTimer1: TVrHPTimer;
    VrHPTimeBase1: TVrHPTimeBase;
    cbAudioOutputTempDisabled: TCheckBox;
    Label4: TLabel;
    edAudioOutputTempDisabledDuration: TAdvSpinEdit;
    Label8: TLabel;
    ALPPMMeter1: TALPPMMeter;
    Label18: TLabel;
    lblMidiOutLastVel0: TLabel;
    lblMidiOutLastVel1: TLabel;
    Label23: TLabel;
    cbAudioOutVolFollowAudioInLevel: TCheckBox;
    lblAudioOutLastVol0: TLabel;
    Label28: TLabel;
    lblAudioOutLastVol1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TimerMidiOutTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lstMidiOutChange(Sender: TObject);
    procedure ActAppAboutExecute(Sender: TObject);
    procedure ActAppCloseExecute(Sender: TObject);
    procedure ALGenericFilter1ProcessData(Sender: TObject;
      InBuffer: IALAudioBuffer; var OutBuffer: IALAudioBuffer;
      var SendOutputData: Boolean);
    procedure ActTriggerStartExecute(Sender: TObject);
    procedure ActTriggerStopExecute(Sender: TObject);
    procedure lstInputDevicesChange(Sender: TObject);
    procedure edAudioTrigLeftThresChange(Sender: TObject);
    procedure lstMidiOutNote0Change(Sender: TObject);
    procedure lstMidiOutChannelChange(Sender: TObject);
    procedure lstAudioInputBufferSizeChange(Sender: TObject);
    procedure lstAudioInputSampleRateChange(Sender: TObject);
    procedure lstAudioInputBitsChange(Sender: TObject);
    procedure lstAudioInputChannelsChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure lstOutputDevicesChange(Sender: TObject);
    procedure rbStartMidiNote0Click(Sender: TObject);
    procedure rbStartMidiNote1Click(Sender: TObject);
    procedure btnBrowseAudioFile0Click(Sender: TObject);
    procedure btnBrowseAudioFile1Click(Sender: TObject);
    procedure edAudioOutFileName0Change(Sender: TObject);
    procedure edAudioOutFileName1Change(Sender: TObject);
    procedure VrHPTimer0HighPrecisionTimer(Seconds, Delta: Extended;
      N: Int64);
    procedure VrHPTimer1HighPrecisionTimer(Seconds, Delta: Extended;
      N: Int64);
    procedure cbAudioOutputTempDisabledClick(Sender: TObject);
    procedure edAudioOutputTempDisabledDurationChange(Sender: TObject);
    procedure ALPPMMeter1ValueChange(Sender: TObject; AChannel: Integer;
      AValue, AMax: Real);
  private
    { Dclarations prives }
    // MIDI
    procedure MIDI_Out_Create;
    procedure MIDI_Out_Init;
    procedure MIDI_Out_Free;
    procedure MIDI_Out_PortsGetAvailable(var lst: TStringList);
    function  MIDI_Out_SetOpened(bState: boolean): boolean;
    procedure MIDI_Out_Open;
    procedure MIDI_Out_Close;
    procedure MidiOutMidiOutput(Sender: TObject);
    procedure Audio_Init;
    procedure Audio_In_GetDevices;
    procedure Audio_Out_GetDevices;
    procedure Audio_In_Close;
    procedure Audio_In_Open;
    procedure Audio_In_SetOpened(bState: boolean);
    procedure App_GUIRefresh;
    procedure Audio_In_SetDevice(sAudioDeviceName: string);
    procedure UserPrefs_Load;
    procedure UserPrefs_Save;
    procedure UserPrefs_Apply;
    procedure MIDI_Out_SetDevice(sMidiDeviceName: string);
    procedure Audio_AnalyseLevel(Left, Right: double);
    procedure MIDI_Out_NotesListPopulate;
    procedure MIDI_Out_SendNote(iStatus, iData1, iData2: byte);
    function  MIDI_NoteStrToNoteCode(sNote: string): byte;
    procedure Analyse_Start;
    procedure Analyse_Stop;
    procedure Audio_Out_Close;
    procedure Audio_Out_Open;
    procedure Audio_Out_SetOpened(bState: boolean);
    procedure Audio_Out_SetDevice(sAudioDeviceName: string);
    function  Audio_Out_GetVolume(iMin, iMax, iVal: double): double;
    procedure MIDI_Init;
    procedure WavePlayers_Init;
    procedure WavePlayer_SetFileName(idx: integer; sFile: string);
    procedure WavePlayer_Play(idx: integer; Vol: double);
    procedure WavePlayer_Stop(idx: integer);
    procedure MIDI_Out_SetNoteOff(idx: integer);
    procedure MIDI_Out_SetNoteOn(idx: integer; iNoteVel: integer);
    function  MIDI_Out_GetNoteVelocity(iMin, iMax, iVal: double): integer;
  public
    { Dclarations publiques }
  end;


var
  fmMain: TfmMain;
  FWavePlayers: TMyWavePlayers;
  FMidi: TMyMidi;
  FAudio: TMyAudio;
  FAudioParams: TAudioParams;
  bAppFinalization: boolean;
  bAppClosing: boolean;
  AppIniFileName: string;
  bReadyToStop: boolean;
  bRunning: boolean;
  bStopRequest: boolean;

implementation

uses
  uRes, uMaths, uVumeter,
  frmAbout;

{$R *.DFM}

procedure Delay(ms: Longword; idle: boolean);
var
  t: Longword;
begin
  t := getTickCount;
  repeat
    if idle then
      application.processMessages;
  until (getTickCount - t) > ms;
end;


procedure TfmMain.FormCreate(Sender: TObject);
begin
  bStopRequest := false;
  bAppClosing := false;
  bAppFinalization := false;

  // path
  AppIniFileName := changeFileExt(Application.ExeName, '.ini');

  // Wave player
  WavePlayers_Init;

  // Audio
  Audio_Init;

  // vumeters
  with FVumeters do
  begin
    Left.Vu := VuAudioLeft;
    Right.Vu := VuAudioRight;
    RefreshInterval := 100;
    MinLevelInDb := FAudioParams.MinLevelInDb;
    MaxLevelInDb := FAudioParams.MaxLevelInDb;
    VuMeters_SetLimits(
      trunc(FAudioParams.MinLevelInDb), trunc(FAudioParams.MaxLevelInDb));
    Vumeters_Reset;
  end;


  // Midi
  Midi_Init;

  // load user prefs
  UserPrefs_Load;

  // Misc
  PageControl1.ActivePageIndex := 0;
  scAudioTrigLeftThres.MinValue := FAudioParams.MinLevelInDb;
  scAudioTrigLeftThres.MaxValue := FAudioParams.MaxLevelInDb;
  scAudioTrigLeftThres.Position := edAudioTrigLeftThres.Value;
  scAudioTrigRightThres.MinValue := FAudioParams.MinLevelInDb;
  scAudioTrigRightThres.MaxValue := FAudioParams.MaxLevelInDb;
  scAudioTrigRightThres.Position := edAudioTrigRightThres.Value;
  edAudioTrigLeftThresChange(nil);
  ActTriggerStopExecute(nil);

end;

procedure TfmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  bAppClosing := true;
  if bRunning then
  begin
    MIDI_Out_Close;
    Delay(600, true);
    MIDI_Out_Free;
    Delay(600, true);
    Audio_Out_Close;
    Delay(200, true);
    Audio_In_Close;
    Delay(200, true);
    WavePlayer_Stop(0);
    WavePlayer_Stop(1);
    Delay(200, true);
  end;
  Delay(500, true);
end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UserPrefs_Save;
end;

procedure TfmMain.ActAppAboutExecute(Sender: TObject);
var
  frm: TFmAbout;
begin
  frm := TFmAbout.create(self);
  try
    frm.showModal;
  finally
    frm.Free;
  end;
end;

procedure TfmMain.ActAppCloseExecute(Sender: TObject);
begin
  close;
end;

procedure TfmMain.WavePlayers_Init;
begin
  try
    with FWavePlayers[0] do
    begin
      if (not assigned(WP)) then
        WP := VrWave0;
        //WP := TWavePlayer.Create;
    end;
    with FWavePlayers[1] do
    begin
      if (not assigned(WP)) then
        WP := VrWave1;
        //WP := TWavePlayer.Create;
    end;
  except
  end;
end;

procedure TfmMain.WavePlayer_SetFileName(idx: integer; sFile: string);
begin
  try
    with FWavePlayers[idx] do
    begin
      if (assigned(WP) and FileExists(sFile)) then
      begin
          WP.Sound.LoadFromFile(sFile);
      end;
    end;
  except
  end;
end;

procedure TfmMain.WavePlayer_Play(idx: integer; Vol: double);
begin
  try
    with FWavePlayers[idx] do
    begin
      if assigned(WP) then
      begin
        WP.Play;
        case idx of
          0 : VrHPTimer0.Enabled := true;
          1 : VrHPTimer1.Enabled := true;
        end;
        FileStartLocked := true;
      end;
    end;
  except
  end;
end;

procedure TfmMain.WavePlayer_Stop(idx: integer);
begin
  try
    with FWavePlayers[idx] do
    begin
      if assigned(WP) then
        WP.Stop;
    end;
  except
  end;
end;


procedure TfmMain.Audio_Init;
begin
  with FAudioParams do
  begin
    BufferSize := 1024;
    Bits := 16;
    SampleRate := 44100;
    Channels := 2;         // stereo
    MaxValue := 32767;     // 16 bits
    MinLevelIndB := trunc(MaxValueToMinDb(MaxValue));
    MaxLevelInDb := 0;
  end;
  Audio_In_GetDevices;
  Audio_Out_GetDevices;
end;

procedure TfmMain.MIDI_Out_NotesListPopulate;
var
  i, iOctave, Inote: integer;
  sOctave, sNote, s: string;
begin
  lstMidiOutChannel.Clear;
  for i := 0 to 15 do
    lstMidiOutChannel.Items.Add(IntToStr(i + 1));

  lstMidiOutNote0.Clear;
  lstMidiOutNote1.Clear;
  for iOctave := 0 to 10 do
  begin
    sOctave := intToStr(iOctave - 2);
    for iNote := 0 to 11 do
    begin
      case iNote of
        0 : sNote := 'Do';
        1 : sNote := 'Do#';
        2 : sNote := 'R';
        3 : sNote := 'R#';
        4 : sNote := 'Mi';
        5 : sNote := 'Fa';
        6 : sNote := 'Fa#';
        7 : sNote := 'Sol';
        8 : sNote := 'Sol#';
        9 : sNote := 'La';
        10 : sNote := 'La#';
        11 : sNote := 'Si';
      end;
      s := sNote + sOctave;
      lstMidiOutNote0.Items.Add(s);
    end;
  end;
  lstMidiOutNote1.Items.Assign(lstMidiOutNote0.Items);
end;

procedure TfmMain.Audio_In_Open;
begin
  Audio_In_SetOpened(true);
end;

procedure TfmMain.Audio_Out_Open;
begin
  Audio_Out_SetOpened(true);
end;

procedure TfmMain.Audio_In_Close;
begin
  Audio_In_SetOpened(false);
end;

procedure TfmMain.Audio_Out_Close;
begin
  Audio_Out_SetOpened(false);
end;

procedure TfmMain.Audio_In_SetOpened(bState: boolean);
begin
  Screen.Cursor := crHourGlass;
  ledAudioInState.Lit := false;
  try
    if not bState then
      ALGenericFilter1.Enabled := false;
    ALAudioIn1.Enabled := bState;
    if bState then
      ALGenericFilter1.Enabled := true;
    ledAudioInState.Lit := bState;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfmMain.Audio_Out_SetOpened(bState: boolean);
begin
  Screen.Cursor := crHourGlass;
  ledAudioOutState.Lit := false;
  try
    ALAudioOut1.Enabled := bState;
    ledAudioOutState.Lit := bState;
  finally
    Screen.Cursor := crDefault;
  end;
end;

function  TfmMain.Audio_Out_GetVolume(iMin, iMax, iVal: double): double;
begin
  //iMin = Audio threshold, in dB
  //iMax actually fixed to 0.0 dBFS
  //iVal = last detected audio level, in dB
  if cbAudioOutVolFollowAudioInLevel.Checked then
    Result := trunc(100 - (Abs(iVal) * (100 / Abs(iMin))))
  else
    Result := 100;
  //lblDebug.Caption := format('%f, %f, %f', [iMin, iMax, iVal]);
end;

procedure TfmMain.Audio_In_GetDevices;
begin
  try
    lstInputDevices.clear;
    ALAudioIn1.Device.GetDeviceList(lstInputDevices.Items);
  except
  end;
  if lstInputDevices.Items.Count > 0 then
  begin
    lstInputDevices.Items.Insert(0, sAudioInputDeviceDefault);
    lstInputDevices.ItemIndex := 0;
  end;
end;

procedure TfmMain.Audio_Out_GetDevices;
begin
  try
    lstOutputDevices.clear;
    ALAudioOut1.Device.GetDeviceList(lstOutputDevices.Items);
  except
  end;
  if lstOutputDevices.Items.Count > 0 then
  begin
    lstOutputDevices.Items.Insert(0, sAudioOutputDeviceDefault);
    lstOutputDevices.ItemIndex := 0;
  end;
end;

procedure TfmMain.TimerMidiOutTimer(Sender: TObject);
begin
  TimerMidiOut.Enabled := false;
  LedMidiOutData.Lit := false;
end;

procedure TfmMain.ActTriggerStartExecute(Sender: TObject);
begin
  Analyse_Start;
end;

procedure TfmMain.Analyse_Start;
begin
  bReadyToStop := false;
  bStopRequest := false;
  bRunning := true;
  Audio_In_Open;
  Audio_Out_Open;
  MIDI_Out_Open;
  App_GUIRefresh;
end;

procedure TfmMain.ActTriggerStopExecute(Sender: TObject);
begin
  bStopRequest := true;
  Analyse_Stop;
end;

procedure TfmMain.Analyse_Stop;
var
  T0, T1, iTimeOut: integer;
begin
  // wait for "ready to stop" flag
  iTimeOut := 1000;
  T0 := GetTickCount;
  repeat
    T1 := GetTickCount;
  until (bReadyToStop or ((T1 - T0) > iTimeOut));
  bRunning := false;
  Audio_In_Close;
  Audio_Out_Close;
  MIDI_Out_Close;
  Vumeters_Reset;
  lblLeftLevelInDb.Caption := '-.--';
  lblRightLevelInDb.Caption := '-.--';
  App_GUIRefresh;
end;


procedure TfmMain.App_GUIRefresh;
begin
  if (bAppClosing or bAppFinalization) then exit;
  lstInputDevices.Enabled := (not bRunning);
  //lstAudioInputChannels.Enabled := (not bRunning);
  lstAudioInputBufferSize.Enabled := (not bRunning);
  lstAudioInputSampleRate.Enabled := (not bRunning);
  //lstAudioInputBits.Enabled := (not bRunning);
  lstMidiOut.Enabled := (not bRunning);
  ActTriggerStart.Enabled := (not bRunning);
  ActTriggerStop.Enabled := bRunning;
end;


procedure TfmMain.lstMidiOutChange(Sender: TObject);
begin
  Midi_Out_SetDevice(lstMidiOut.Items[lstMidiOut.ItemIndex]);
end;


// *****************************************************************
//   MIDI
// *****************************************************************


procedure TfmMain.MIDI_Init;
begin
  MIDI_Out_Create;
  MIDI_Out_Init;
  Midi_Out_NotesListPopulate;
  lstMidiOutChange(lstMidiOut);
end;

procedure TfmMain.MIDI_Out_SetDevice(sMidiDeviceName: string);
begin
  try
    FMidi.FMyMIDIOut.ProductName := sMidiDeviceName;
    FMidi.OutputDeviceName := sMidiDeviceName;
  except
  end;
end;

procedure TfmMain.MidiOutMidiOutput(Sender: TObject);
begin
  //FMIDIOut
end;

function  TfmMain.MIDI_Out_GetNoteVelocity(iMin, iMax, iVal: double): integer;
begin
  //iMin = Audio threshold, in dB
  //iMax actually fixed to 0.0 dBFS
  //iVal = last detected audio level, in dB
  if cbMidiOutVelFollowAudioInLevel.Checked then
    Result := trunc(127 - (Abs(iVal) * (127 / Abs(iMin))))
  else
    Result := 100;
  //lblDebug.Caption := format('%f, %f, %f', [iMin, iMax, iVal]);
end;

procedure TfmMain.MIDI_Out_Create;
begin
  try
    FMidi.FMyMIDIOut := TMidiOutput.Create(fmMain);
  except
    FMidi.FMyMIDIOut := nil;
  end;
end;

procedure TfmMain.MIDI_Out_Free;
begin
  if assigned(FMidi.FMyMIDIOut) then
  begin
    try
      FMidi.FMyMIDIOut.free;
    except
    end;
  end;
end;

procedure TfmMain.MIDI_Out_Init;
var
  lst: TStringList;
  i: integer;
  MidiFound: boolean;
begin
  lstMIDIOut.Clear;
  lstMIDIOut.Items.Add(sNoPortSpecified);
  // search and list all Com Ports available
  lst := TStringList.Create;
  try
    MIDI_Out_PortsGetAvailable(lst);
    MidiFound := (lst.count > 0);
    // populate main Com Ports list in main app form
    if MidiFound then
    begin
      lstMIDIOut.items.Delete(0);  // delete "sNoPortSpecified" item
      for i := 0 to pred(lst.count) do
        lstMIDIOut.Items.Add(lst[i]);
      lstMIDIOut.ItemIndex := 0;
    end;
  finally
    lst.Free;
  end;

  // MIDI Out events
  FMidi.FMyMIDIOut.OnMidiOutput := MidiOutMidiOutput;
end;

procedure TfmMain.MIDI_Out_PortsGetAvailable(var lst: TStringList);
var
  wDevice: Word;
  SaveCursor: TCursor;
begin
  // Load lists of installed MIDI devices
  SaveCursor := screen.Cursor;
  screen.Cursor := crHourGlass;
  lst.clear;
  try
    for wDevice := 0 To FMidi.FMyMIDIOut.NumDevs - 1 do
    begin
      FMidi.FMyMIDIOut.DeviceID := wDevice;
      lst.Add(FMidi.FMyMIDIOut.ProductName);
    end;
  finally
  end;
  screen.Cursor := SaveCursor;
end;

function  TfmMain.MIDI_Out_SetOpened(bState: boolean): boolean;
begin
  result := false;
  try
    LedMidiOutState.Lit := false;
  except
  end;

  Screen.Cursor := crHourGlass;
  try

    // Open
    if bState then begin
      FMidi.FMyMIDIOut.Open;
      result := true;
      Delay(200, true);
      LedMidiOutState.lit := true;
    end

    // or close
    else begin
      FMidi.FMyMIDIOut.Close;
      LedMidiOutState.lit := false;
    end;

  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfmMain.MIDI_Out_Open;
begin
  MIDI_Out_SetOpened(true);
end;

procedure TfmMain.MIDI_Out_Close;
begin
  MIDI_Out_SetOpened(false);
end;

procedure TfmMain.MIDI_Out_SendNote(iStatus, iData1, iData2: byte);
begin
  if bStopRequest then exit;
  if (bAppClosing or bAppFinalization) then exit;
  try
    //if FMidi.FMyMIDIOut.Close then exit;
    FMidi.FMyMIDIOut.PutShort(iStatus, iData1, iData2);
  except
  end;
  LedMidiOutData.Lit := (FMidi.Note0On or FMidi.Note1On);
  TimerMidiOut.Enabled := true;
end;

function TfmMain.MIDI_NoteStrToNoteCode(sNote: string): byte;
begin
  // nothing at the moment
end;

procedure TfmMain.ALGenericFilter1ProcessData(Sender: TObject;
  InBuffer: IALAudioBuffer; var OutBuffer: IALAudioBuffer;
  var SendOutputData: Boolean);
var
  DataAccess: IALAudioDataAccess;
  i: integer;
  iL, iR: double;
  iLeftPeakPos, iRightPeakPos: double;
  iLeftPeakNeg, iRightPeakNeg: double;
  iLeftPeakPosDb, iRightPeakPosDb: double;
  iLeftPeakNegDb, iRightPeakNegDb: double;
begin
  if bStopRequest then
  begin
    bReadyToStop := true;
    exit;
  end;
  if (bAppClosing or bAppFinalization) then exit;
  DataAccess := InBuffer.Data();
  DataAccess.BeginRead();

  // peak calculation and clip search
  iLeftPeakPos := 0.0;
  iLeftPeakNeg := 0.0;
  iRightPeakPos := 0.0;
  iRightPeakNeg := 0.0;

  try

  for i := 0 to DataAccess.GetSize() - 1 do
  begin
    if bStopRequest then
    begin
      bReadyToStop := true;
      exit;
    end;
    if (bAppClosing or bAppFinalization) then exit;

    // always calc for Left channel (mono or stereo)

    // peak
    if DataAccess[i, 0] > iLeftPeakPos then
      iLeftPeakPos := DataAccess[i, 0]
    else if DataAccess[i, 0] < iLeftPeakNeg then
      iLeftPeakNeg := DataAccess[i, 0];

    // calc Right channel only if stereo
    if (FAudioParams.Channels = 2) then
    begin

      // peak
      if DataAccess[i, 1] > iRightPeakPos then
        iRightPeakPos := DataAccess[i, 1]
      else if DataAccess[i, 1] < iRightPeakNeg then
        iRightPeakNeg := DataAccess[i, 1];

    end

    // mono
    else begin
      iRightPeakPos := iLeftPeakPos;
      iRightPeakNeg := iLeftPeakNeg;
    end;

  end;

  except
  end;

  // convert peaks to decibel
  iLeftPeakPosDb  := FloatToDb(iLeftPeakPos);
  iRightPeakPosDb := FloatToDb(iRightPeakPos);
  iLeftPeakNegDb  := FloatToDb(iLeftPeakNeg);
  iRightPeakNegDb := FloatToDb(iRightPeakNeg);

  // search for 0dBFS overload
  if bStopRequest then
  begin
    bReadyToStop := true;
    exit;
  end;
  if (bAppClosing or bAppFinalization) then exit;
  if ((abs(iLeftPeakPos) >= (FAudioParams.MaxValue - 3)) or
      (abs(iLeftPeakNeg) >= (FAudioParams.MaxValue - 3)) or
      (abs(iRightPeakPos) >= (FAudioParams.MaxValue - 3)) or
      (abs(iRightPeakNeg) >= (FAudioParams.MaxValue - 3))) then
    lblClip.Visible := true
  else
    lblClip.Visible := false;

  // threshold passed ?
  if bStopRequest then
  begin
    bReadyToStop := true;
    exit;
  end;
  if (bAppClosing or bAppFinalization) then exit;

  // do analyse
  Audio_AnalyseLevel(iLeftPeakPosDb, iRightPeakPosDb);

  // draw vumeters
  if bStopRequest then
  begin
    bReadyToStop := true;
    exit;
  end;
  if (bAppClosing or bAppFinalization) then exit;
  with FVumeters do
  begin
    T1 := GetTickCount;
    if ((T1 - T0) > RefreshInterval) then
    begin
      VuMeter_SetPosition(Left, iLeftPeakPosDb);
      VuMeter_SetPosition(Right, iRightPeakPosDb);
      lblLeftLevelInDb.Caption := format('%.2f', [iLeftPeakPosDb]);
      lblRightLevelInDb.Caption := format('%.2f', [iRightPeakPosDb]);
      T0 := GetTickCount;
    end;
  end;

end;

procedure TfmMain.Audio_AnalyseLevel(Left, Right: double);
var
  dLeftThres, dRightThres: double;
  bThresReached0, bThresReached1: boolean;
  iLeftVel, iRightVel: integer;
  iLeftVol, iRightVol: double;
begin
  if bStopRequest then
  begin
    bReadyToStop := true;
    exit;
  end;
  if (bAppClosing or bAppFinalization) then exit;

  dLeftThres := edAudioTrigLeftThres.Value;
  dRightThres := edAudioTrigRightThres.Value;
  ledLeftThres.lit := (Left > dLeftThres);
  ledRightThres.lit := (Right > dRightThres);
  bThresReached0 := (Left > dLeftThres);
  bThresReached1 := (Right > dRightThres);

  // send MIDI note ? - Channel Left
  if rbStartMidiNote0.checked then
  begin
    // send Note On (left audio channel) ?
    if bThresReached0 then
    begin
      if (not FMidi.Note0On) then
      begin
        // get velocity value
        iLeftVel := MIDI_Out_GetNoteVelocity(dLeftThres, 0.0, Left);
        lblMidiOutLastVel0.Caption := IntToStr(iLeftVel);
        // send Note On
        MIDI_Out_SetNoteOn(0, iLeftVel);
      end;
    end
    // send Note Off ?
    else begin
      //lblMidiOutLastVel0.Caption := IntToStr(0);
      // only send Note Off if Note On previously sent
      if (FMidi.Note0On) then
        MIDI_Out_SetNoteOff(0);
    end;
  end

  // or start audio file ?
  else if rbStartAudioFile0.checked then
  begin
    if bThresReached0 then
      if not FWavePlayers[0].FileStartLocked then
      begin
        // get volume value
        iLeftVol := Audio_Out_GetVolume(dLeftThres, 0.0, Left);
        lblAudioOutLastVol0.Caption := format('%f', [iLeftVol]);
        WavePlayer_Play(0, iLeftVol);
      end;
  end;

  // send MIDI note ? - Channel Right
  if rbStartMidiNote1.checked then
  begin
    // send Note On (right audio channel) ?
    if bThresReached1 then
    begin
      if (not FMidi.Note1On) then
      begin
        // get velocity value
        iRightVel := MIDI_Out_GetNoteVelocity(dRightThres, 0.0, Right);
        lblMidiOutLastVel1.Caption := IntToStr(iRightVel);
        // send Note On
        MIDI_Out_SetNoteOn(1, iRightVel);
      end;
    end
    // send Note Off ?
    else begin
      //lblMidiOutLastVel1.Caption := IntToStr(0);
      if (FMidi.Note1On) then
        MIDI_Out_SetNoteOff(1);
    end;
  end

  // or start audio file ?
  else if rbStartAudioFile1.checked then
  begin
    if bThresReached1 then
      if not FWavePlayers[1].FileStartLocked then
      begin
        // get volume value
        iRightVol := Audio_Out_GetVolume(dRightThres, 0.0, Right);
        lblAudioOutLastVol1.Caption := format('%f', [iRightVol]);
        // play wave file
        WavePlayer_Play(1, iRightVol);
      end;
  end;


end;

procedure TfmMain.MIDI_Out_SetNoteOn(idx: integer; iNoteVel: integer);
var
  iNoteOn, iNoteVal: byte;
begin
  iNoteOn := $90 + lstMidiOutChannel.ItemIndex;
  //iNoteVel = 64 - fixed at the moment

  case idx of
    0 : begin
          iNoteVal := lstMidiOutNote0.ItemIndex;
          FMidi.Note0On := true;
        end;
    1 : begin
          iNoteVal := lstMidiOutNote1.ItemIndex;
          FMidi.Note1On := true;
        end;
  end;
  Midi_Out_SendNote(iNoteOn, iNoteVal, iNoteVel);
end;

procedure TfmMain.MIDI_Out_SetNoteOff(idx: integer);
var
  iNoteOff, iNoteVal, iNoteVel: byte;
begin
  iNoteOff := $80 + lstMidiOutChannel.ItemIndex;
  iNoteVel := 64;  // fixed at the moment

  case idx of
    0 : begin
          iNoteVal := lstMidiOutNote0.ItemIndex;
          FMidi.Note0On := false;
          //iNoteVel := MIDI_Get
        end;
    1 : begin
          iNoteVal := lstMidiOutNote1.ItemIndex;
          FMidi.Note1On := false;
        end;
  end;
  Midi_Out_SendNote(iNoteOff, iNoteVal, iNoteVel);
end;


procedure TfmMain.lstInputDevicesChange(Sender: TObject);
begin
  with lstInputDevices do
    Audio_In_SetDevice(Items[ItemIndex]);
end;

procedure TfmMain.lstOutputDevicesChange(Sender: TObject);
begin
  with lstOutputDevices do
    Audio_Out_SetDevice(Items[ItemIndex]);
end;

procedure TfmMain.lstAudioInputChannelsChange(Sender: TObject);
var
  i: integer;
begin
  try
    with lstAudioInputChannels do
      i := ItemIndex + 1;
    ALAudioIn1.AudioFormat.BufferSize := i;
    FAudioParams.BufferSize := i;
  except
  end;
end;

procedure TfmMain.lstAudioInputBufferSizeChange(Sender: TObject);
var
  i: integer;
begin
  try
    with lstAudioInputBufferSize do
      i := strToInt(Items[ItemIndex]);
    ALAudioIn1.AudioFormat.BufferSize := i;
    FAudioParams.BufferSize := i;
  except
  end;
end;

procedure TfmMain.lstAudioInputSampleRateChange(Sender: TObject);
var
  i: integer;
begin
  try
    with lstAudioInputSampleRate do
      i := strToInt(Items[ItemIndex]);
    ALAudioIn1.AudioFormat.SampleRate := i;
    FAudioParams.SampleRate := i;
  except
  end;
end;

procedure TfmMain.lstAudioInputBitsChange(Sender: TObject);
var
  i: integer;
begin
  try
    with lstAudioInputBits do
      i := strToInt(Items[ItemIndex]);
    ALAudioIn1.AudioFormat.Bits := i;
    FAudioParams.Bits := i;
  except
  end;
end;

procedure TfmMain.Audio_In_SetDevice(sAudioDeviceName: string);
begin
  try
    ALAudioIn1.Device.DeviceName := sAudioDeviceName;
    FAudio.InputDeviceName := sAudioDeviceName;
  except
  end;
end;

procedure TfmMain.Audio_Out_SetDevice(sAudioDeviceName: string);
begin
  try
    ALAudioOut1.Device.DeviceName := sAudioDeviceName;
    FAudio.OutputDeviceName := sAudioDeviceName;
  except
  end;
end;

procedure TfmMain.edAudioTrigLeftThresChange(Sender: TObject);
begin
  scAudioTrigLeftThres.Position := edAudioTrigLeftThres.Value;
  scAudioTrigRightThres.Position := edAudioTrigRightThres.Value;
  FAudio.LeftThres := edAudioTrigLeftThres.Value;
  FAudio.RightThres := edAudioTrigRightThres.Value;
end;


procedure TfmMain.UserPrefs_Load;
var
  ini: TIniFile;
begin
  ini := TIniFile.Create(AppIniFileName);
  try

    // Audio In
    with FAudio, FAudioParams do
    begin
      InputDeviceName :=
        ini.ReadString(sIniMainSection, sAudioInputDeviceName, sAudioInputDeviceDefault);
      Channels := ini.ReadInteger(sIniMainSection, sAudioInputChannels, 2);
      BufferSize := ini.ReadInteger(sIniMainSection, sAudioInputBufferSize, 1024);
      SampleRate := ini.ReadInteger(sIniMainSection, sAudioInputSampleRate, 44100);
      Bits := ini.ReadInteger(sIniMainSection, sAudioInputBits, 16);
    end;

    // treatment
    with FAudio do
    begin
      LeftThres := ini.ReadFloat(sIniMainSection, sAudioTrigLeftThres, -45.0);
      RightThres := ini.ReadFloat(sIniMainSection, sAudioTrigRightThres, -45.0);
    end;
    if ini.ReadBool(sIniMainSection, sAudioTrigStartMidiNote0, true) then
      rbStartMidiNote0.Checked := true
    else
      rbStartAudioFile0.Checked := true;
    if ini.ReadBool(sIniMainSection, sAudioTrigStartMidiNote1, true) then
      rbStartMidiNote1.Checked := true
    else
      rbStartAudioFile1.Checked := true;
    edAudioOutFileName0.text := ini.ReadString(sIniMainSection, sAudioOutFileName0, '');
    edAudioOutFileName1.text := ini.ReadString(sIniMainSection, sAudioOutFileName1, '');

    // Midi
    with FMidi do
    begin
      OutputDeviceName := ini.ReadString(sIniMainSection, sMidiOutDeviceName, '');
      OutVelFollowAudioInLevel0 := ini.ReadBool(sIniMainSection, sMidiOutVelFollowAudioInLevel0, true);
      OutVelFollowAudioInLevel1 := ini.ReadBool(sIniMainSection, sMidiOutVelFollowAudioInLevel1, true);
      Channel := ini.ReadInteger(sIniMainSection, sMidiOutChannel, 1);
      Note0Str := ini.ReadString(sIniMainSection, sMidiOutNote0, 'Do3');
      Note1Str := ini.ReadString(sIniMainSection, sMidiOutNote1, 'Do3');
    end;

    // Audio out
    with FAudio, FAudioParams do
    begin
      OutputDeviceName :=
        ini.ReadString(sIniMainSection, sAudioOutputDeviceName, sAudioOutputDeviceDefault);
      OutVolFollowAudioInLevel0 := ini.ReadBool(sIniMainSection, sAudioOutVolFollowAudioInLevel0, false);
      OutVolFollowAudioInLevel1 := ini.ReadBool(sIniMainSection, sAudioOutVolFollowAudioInLevel1, false);
      edAudioOutputTempDisabledDuration.FloatValue :=
        ini.ReadFloat(sIniMainSection, sAudioOutputTempDisabledDuration, 40);
    end;

  finally
    ini.Free;
  end;
  UserPrefs_Apply;
end;

procedure TfmMain.UserPrefs_Apply;
var
  idx: integer;
begin
  // Audio
  with FAudio, FAudioParams do
  begin
    try
      ALAudioIn1.Device.DeviceName := InputDeviceName;
    except end;
    try
      lstInputDevices.ItemIndex :=
        lstInputDevices.Items.IndexOf(ALAudioIn1.Device.DeviceName);
    except end;
    try
      ALAudioOut1.Device.DeviceName := OutputDeviceName;
    except end;
    try
      lstOutputDevices.ItemIndex :=
        lstOutputDevices.Items.IndexOf(ALAudioOut1.Device.DeviceName);
    except end;
    try
      lstAudioInputChannels.ItemIndex := 1;  // stro
        lstAudioInputChannels.Items.IndexOf(intToStr(Channels));
      ALAudioIn1.AudioFormat.Channels := Channels;
      //lstAudioInputChannelsChange(nil);
    except end;
    try
      lstAudioInputBufferSize.ItemIndex :=
        lstAudioInputBufferSize.Items.IndexOf(intToStr(BufferSize));
      ALAudioIn1.AudioFormat.BufferSize := BufferSize;
      //lstAudioInputBufferSizeChange(nil);
    except end;
    try
      lstAudioInputSampleRate.ItemIndex :=
        lstAudioInputSampleRate.Items.IndexOf(intToStr(SampleRate));
      ALAudioIn1.AudioFormat.SampleRate := SampleRate;
      //lstAudioInputSampleRateChange(nil);
    except end;
    try
      lstAudioInputBits.ItemIndex :=
        lstAudioInputBits.Items.IndexOf(intToStr(Bits));
      ALAudioIn1.AudioFormat.Bits := Bits;
      //lstAudioInputBitsChange(nil);
    except end;
  end;

  // treatments
  with FAudio do
  begin
    edAudioTrigLeftThres.OnChange := nil;
    edAudioTrigRightThres.OnChange := nil;
    edAudioTrigLeftThres.FloatValue := LeftThres;
    edAudioTrigRightThres.FloatValue := RightThres;
    edAudioTrigLeftThres.OnChange := edAudioTrigLeftThresChange;
    edAudioTrigRightThres.OnChange := edAudioTrigLeftThresChange;
  end;
  rbStartMidiNote0Click(nil);
  rbStartMidiNote1Click(nil);

  // Midi
  with FMidi do
  begin
    cbMidiOutVelFollowAudioInLevel.checked := OutVelFollowAudioInLevel0;
    lstMidiOutChannel.ItemIndex := Channel - 1;
    lstMidiOutNote0.ItemIndex := lstMidiOutNote0.Items.IndexOf(Note0Str);
    lstMidiOutNote1.ItemIndex := lstMidiOutNote1.Items.IndexOf(Note1Str);
    lstMidiOutNote0Change(nil);
    idx := lstMidiOut.Items.IndexOf(FMidi.OutputDeviceName);
    if idx > -1 then
    begin
      lstMidiOut.ItemIndex := idx;
      FMidi.FMyMIDIOut.ProductName := FMidi.OutputDeviceName;
    end;
  end;

  // audio Out
  with FAudio do
  begin
    cbAudioOutVolFollowAudioInLevel.checked := OutVolFollowAudioInLevel0;
    edAudioOutputTempDisabledDurationChange(nil);
  end;
end;

procedure TfmMain.UserPrefs_Save;
var
  ini: TIniFile;
begin
  ini := TIniFile.Create(AppIniFileName);
  try

    // Audio
    with FAudio, FAudioParams do
    begin
      ini.WriteString(sIniMainSection, sAudioInputDeviceName,
        InputDeviceName);
      ini.WriteInteger(sIniMainSection, sAudioInputChannels, Channels);
      ini.WriteInteger(sIniMainSection, sAudioInputBufferSize, BufferSize);
      ini.WriteInteger(sIniMainSection, sAudioInputSampleRate, SampleRate);
      ini.WriteInteger(sIniMainSection, sAudioInputBits, Bits);
    end;

    // treatment
    with FAudio do
    begin
      ini.WriteFloat(sIniMainSection, sAudioTrigLeftThres, LeftThres);
      ini.WriteFloat(sIniMainSection, sAudioTrigRightThres, RightThres);
    end;
    ini.WriteBool(sIniMainSection, sAudioTrigStartMidiNote0, rbStartMidiNote0.Checked);
    ini.WriteBool(sIniMainSection, sAudioTrigStartMidiNote1, rbStartMidiNote1.Checked);
    ini.WriteString(sIniMainSection, sAudioOutFileName0, edAudioOutFileName0.text);
    ini.WriteString(sIniMainSection, sAudioOutFileName1, edAudioOutFileName1.text);

    // Midi
    with FMidi do
    begin
      ini.WriteString(sIniMainSection, sMidiOutDeviceName, OutputDeviceName);
      ini.WriteBool(sIniMainSection, sMidiOutVelFollowAudioInLevel0, cbMidiOutVelFollowAudioInLevel.checked);
      ini.WriteBool(sIniMainSection, sMidiOutVelFollowAudioInLevel1, cbMidiOutVelFollowAudioInLevel.checked);
      ini.WriteInteger(sIniMainSection, sMidiOutChannel, Channel);
      ini.WriteString(sIniMainSection, sMidiOutNote0, Note0Str);
      ini.WriteString(sIniMainSection, sMidiOutNote1, Note1Str);
    end;

    // audio Out
    with FAudio do
    begin
      ini.WriteString(sIniMainSection, sAudioOutputDeviceName,
        OutputDeviceName);
      ini.WriteBool(sIniMainSection, sAudioOutVolFollowAudioInLevel0, cbAudioOutVolFollowAudioInLevel.checked);
      ini.WriteBool(sIniMainSection, sAudioOutVolFollowAudioInLevel1, cbAudioOutVolFollowAudioInLevel.checked);
      ini.WriteFloat(sIniMainSection, sAudioOutputTempDisabledDuration,
        edAudioOutputTempDisabledDuration.Value);
    end;

  finally
    ini.Free;
  end;
end;

procedure TfmMain.lstMidiOutNote0Change(Sender: TObject);
begin
  with FMidi do
  begin
    Note0Str := lstMidiOutNote0.Items[lstMidiOutNote0.ItemIndex];
    Note0Data := Midi_NoteStrToNoteCode(Note0Str);
    Note1Str := lstMidiOutNote1.Items[lstMidiOutNote1.ItemIndex];
    Note1Data := Midi_NoteStrToNoteCode(Note1Str);
  end;
end;

procedure TfmMain.lstMidiOutChannelChange(Sender: TObject);
begin
  FMidi.Channel := lstMidiOutChannel.ItemIndex + 1;
end;

procedure TfmMain.rbStartMidiNote0Click(Sender: TObject);
begin
  WavePlayer_Stop(0);
  lstMidiOutNote0.Enabled := rbStartMidiNote0.Checked;
  edAudioOutFileName0.Enabled := rbStartAudioFile0.Checked;
end;

procedure TfmMain.rbStartMidiNote1Click(Sender: TObject);
begin
  WavePlayer_Stop(1);
  lstMidiOutNote1.Enabled := rbStartMidiNote1.Checked;
  edAudioOutFileName1.Enabled := rbStartAudioFile1.Checked;
end;

procedure TfmMain.btnBrowseAudioFile0Click(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    if execute then
    begin
    end;
  end;
end;

procedure TfmMain.btnBrowseAudioFile1Click(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    if execute then
    begin
    end;
  end;
end;

procedure TfmMain.edAudioOutFileName0Change(Sender: TObject);
begin
  //edAudioOutFileName0.FileName := edAudioOutFileName0.Text;
  WavePlayer_SetFileName(0, edAudioOutFileName0.FileName);
end;

procedure TfmMain.edAudioOutFileName1Change(Sender: TObject);
begin
  //edAudioOutFileName1.FileName := edAudioOutFileName1.Text;
  WavePlayer_SetFileName(1, edAudioOutFileName1.FileName);
end;

procedure TfmMain.VrHPTimer0HighPrecisionTimer(Seconds, Delta: Extended;
  N: Int64);
begin
  VrHPTimer0.Enabled := false;
  with FWavePlayers[0] do
    FileStartLocked := false;
end;

procedure TfmMain.VrHPTimer1HighPrecisionTimer(Seconds, Delta: Extended;
  N: Int64);
begin
  VrHPTimer1.Enabled := false;
  with FWavePlayers[1] do
    FileStartLocked := false;
end;

procedure TfmMain.cbAudioOutputTempDisabledClick(Sender: TObject);
begin
  edAudioOutputTempDisabledDuration.Enabled := cbAudioOutputTempDisabled.Checked;
end;

procedure TfmMain.edAudioOutputTempDisabledDurationChange(Sender: TObject);
begin
  VrHPTimer0.TimePeriod := (edAudioOutputTempDisabledDuration.Value / 1000);
  VrHPTimer1.TimePeriod := VrHPTimer0.TimePeriod;
end;

procedure TfmMain.ALPPMMeter1ValueChange(Sender: TObject;
  AChannel: Integer; AValue, AMax: Real);
begin
  exit;
  VuAudioLeft.MaxValue := trunc(AMax);
  VuAudioRight.MaxValue := trunc(AMax);
  case AChannel of
    0 : VuMeter_SetPosition(FVumeters.Left, trunc(AValue));
    1 : VuMeter_SetPosition(FVumeters.Right, trunc(AValue));
  end;
end;

initialization

finalization
  bAppFinalization := true;


end.
