unit uMaths;

interface

uses
  SysUtils, Dialogs,
  Math, jclMath;

function FloatToDb(iVal: double; iMaxBase: integer): double; overload;
function FloatToDb(iVal: double): double; overload;
function FloatToDbInt(iVal: double): integer;
function MaxValueToMinDb(iMaxVal: integer): double;
function DbToFloat(iVal: double): double;
function DbIntToFloat(iVal: double): double;

implementation

uses
  frmMain;

function FloatToDb(iVal: double; iMaxBase: integer): double;
begin
  try
    if iVal > 0 then
      Result := 20 * log10(iVal / iMaxBase)
    else if iVal < 0 then
      Result := 20 * log10(abs(iVal) / iMaxBase)
    else // if iVal = 0 then
      Result := 20 * log10(1 / iMaxBase);
  except
    //showmessage('iVal = ' + inttostr(iVal) + ' - iMaxBase = ' + inttostr(iMaxBase));
    Result := 20 * log10(1 / iMaxBase);
  end;
end;

function FloatToDb(iVal: double): double;
begin
  result := FloatToDb(iVal, FAudioParams.MaxValue);
end;

function FloatToDbInt(iVal: double): integer;
begin
  result := trunc(FloatToDb(iVal, FAudioParams.MaxValue));
end;

function MaxValueToMinDb(iMaxVal: integer): double;
begin
  result := FloatToDb(1, iMaxVal) - 6;
end;

function DbToFloat(iVal: double): double;
begin
  result := 0.0;
end;

function DbIntToFloat(iVal: double): double;
begin
  result := 0.0;
end;

end.
